unit DELCOMObjPersistFile;
{..$DEFINE Debug}
{
   Daniel U. Thibault
   <D.U.Thibault@Bigfoot.com>
   30 January 1999
   Updated 17 February 1999
    1999 Daniel U. Thibault.  All Rights Reserved.

   This is freeware.  No legally binding promises.  If you use the 
   component or any part of its code, you must include an 
   acknowledgement in the finished code or executable (in the About 
   box and/or the Help file).

   The DEL file IPersistFile implementation.
}
interface

uses
   Windows,
   COMObjPersistFile, { TCOMObjPersistFile }
   ShlObj; { SHChangeNotify }

type
   TDELCOMObjPersistFile = class(TCOMObjPersistFile)
   protected
      function DoSave(FileName : String; Remember : BOOL) : HResult; override;
   end;

implementation

uses
{$IFDEF Debug}
DLLDebug, { Loggit }
{$ENDIF}
   DUTDelShellUtils;

{ ########## TDELCOMObjPersistFile ########## }

function TDELCOMObjPersistFile.DoSave(FileName : String; Remember : BOOL) : HResult;
var
   Num : Integer;
begin
   if FileName <> '' then begin
      //Save the object under a different filename.
      Result := E_FAIL;
      Num := GetDelFileNumber(FFileName);
      if Num < 0 then Exit;
      if SetDelFileNumber(Filename, Num) < 0 then Exit;
      SHChangeNotify(SHCNE_UPDATEITEM, SHCNF_PATH or SHCNF_FLUSHNOWAIT, PChar(FileName), Nil);
   end; { then }
   { else
     we were asked to save the "dirty" object under
     its current FFileName; no action necessary.
   }
   Result := S_OK;
end; { TDELCOMObjPersistFile.DoSave }

end. { unit DELCOMObjPersistFile }
 