unit DLLDebug;
{
   A call to the Loggit function sends a string-message to the
   Logger program defined in LOGGER.DPR. It functions as a very
   simple-minded kind of debugging, allowing your program to
   signal the current value of a variable, or whether a certain
   function was activated. And if the Logger program isn't running,
   the messages do no harm.
}
interface

uses
   Windows,
   ActiveX, // was OLE2,
   COMObj, COMServ, // was OleAuto,
   ShlObj,
   Messages;

procedure Loggit(const S : String);

function NameOfIID(const IID : TIID) : String;

const
   { from OLE2.pas }
   IID_IUnknown      : TGUID = (D1:$00000000;D2:$0000;D3:$0000;D4:($C0,$00,$00,$00,$00,$00,$00,$46));
   IID_IClassFactory : TGUID = (D1:$00000001;D2:$0000;D3:$0000;D4:($C0,$00,$00,$00,$00,$00,$00,$46));
   IID_IPersistFile  : TGUID = (D1:$0000010B;D2:$0000;D3:$0000;D4:($C0,$00,$00,$00,$00,$00,$00,$46));

implementation

var
   WM_LOGGIT : Integer;

function ClassIDToString(const ClassID: TCLSID): string;
{
   From OLEAuto.pas
}
var
   P: PWideChar;
begin
   OLECheck(StringFromCLSID(ClassID, P));
   Result := WideCharToString(P);
   CoTaskMemFree(P);
end;

procedure Loggit(const S : String);
var
   MyAtom : TAtom;
begin
   MyAtom := GlobalAddAtom(PChar(S));
   SendMessage(-1, WM_LOGGIT, MyAtom, 0);
   GlobalDeleteAtom(MyAtom);
end;

function NameOfIID(const IID : TIID) : String;
// Add any other IIDs you're interested in
begin
   // IID_IUnknown is returned by IUnknown
   if IsEqualIID(IID, IID_IUnknown) then begin
      Result := 'IID_IUnknown';
   end else if IsEqualIID(IID, IID_IClassFactory) then begin
      Result := 'IID_IClassFactory';
   end else if IsEqualIID(IID, IID_IContextMenu) then begin
      Result := 'IID_IContextMenu';
   end else if IsEqualIID(IID, IID_IShellFolder) then begin
      Result := 'IID_IShellFolder';
   end else if IsEqualIID(IID, IID_IShellExtInit) then begin
      Result := 'IID_IShellExtInit';
   end else if IsEqualIID(IID, IID_IShellPropSheetExt) then begin
      Result := 'IID_IShellPropSheetExt';
   end else if IsEqualIID(IID, IID_IExtractIconA) then begin
      Result := 'IID_IExtractIconA';
   end else if IsEqualIID(IID, IID_IPersistFile) then begin
      Result := 'IID_IPersistFile';
   end else if IsEqualIID(IID, IID_IShellLinkA) then begin
      Result := 'IID_IShellLinkA';
   end else if IsEqualIID(IID, IID_IShellCopyHookA) then begin
      Result := 'IID_IShellCopyHookA';
   end else if IsEqualIID(IID, IID_IFileViewerA) then begin
      Result := 'IID_IFileViewerA';
   end else if IsEqualIID(IID, IID_IEnumIDList) then begin
      Result := 'IID_IEnumIDList';
   end else if IsEqualIID(IID, IID_IFileViewerSite) then begin
      Result := 'IID_IFileViewerSite'
   end else begin
      Result := ClassIDToString(IID);
   end; { else }
end;

initialization
   WM_LOGGIT := RegisterWindowMessage('Debugging Status Message');
end. { unit DLLDebug }
