library DUTDelShellExtensions;
{$DEFINE Debug}
(*
   The DUTDelShellExtensions utility must be used to
   register and unregister the CLSIDs.

   CLSID_DelContextMenu : TGUID = (
      D1:$6A5EF9E1; D2:$DFCE; D3:$11CF; D4:($9A, $34, $44, $45, $53, $54, $00, $00));
   CLSID_DelCopy : TGUID = (
      D1:$6A5EF9E2; D2:$DFCE; D3:$11CF; D4:($9A, $34, $44, $45, $53, $54, $00, $00));
   CLSID_DelDragDrop : TGUID = (
      D1:$6A5EF9E5; D2:$DFCE; D3:$11CF; D4:($9A, $34, $44, $45, $53, $54, $00, $00));
   CLSID_DelDrop : TGUID = (
      D1:$6A5EF9E6; D2:$DFCE; D3:$11CF; D4:($9A, $34, $44, $45, $53, $54, $00, $00));
   CLSID_DelIcon : TGUID = (
      D1:$6A5EF9E4; D2:$DFCE; D3:$11CF; D4:($9A, $34, $44, $45, $53, $54, $00, $00));
   CLSID_DelPropSheet : TGUID = (
      D1:$6A5EF9E3; D2:$DFCE; D3:$11CF; D4:($9A, $34, $44, $45, $53, $54, $00, $00));

   CLSID_DelInfoTip : TGUID = (
      D1:$6A5EF9E7; D2:$DFCE; D3:$11CF; D4:($9A, $34, $44, $45, $53, $54, $00, $00));
*)
uses
{$IFDEF Debug}
DLLDebug,
{$ENDIF}
  Windows,
  COMServ,
  COMObjShellPropSheetExt in 'COMObjShellPropSheetExt.pas',
  DUTShellCopyHook in 'DUTShellCopyHook.pas',
  DUTShellDragDropHandler in 'DUTShellDragDropHandler.pas',
  DUTShellDropHandler in 'DUTShellDropHandler.pas',
  DUTShellIconHandler in 'DUTShellIconHandler.pas',
  DUTShellContextMenu in 'DUTShellContextMenu.pas',
  DUTShellPropertySheet in 'DUTShellPropertySheet.pas',
  DUTDlgTemplate in '..\DUT\DUTDlgTemplate.pas',
  DUTShellInfoTip in 'DUTShellInfoTip.pas';

{$R *.RES}

function DllCanUnloadNow : HResult;
{
   The DLL will be unloaded prematurely in the case of the
   property sheet handler because the TCOMObjShellPropSheetExt is
   released immediately after AddPages concludes.
   This is why we override the COMServ's implementation of
   DllCanUnloadNow --we let it decide on a response ONLY if
   there is no currently loaded instance of the property sheet handler.
}
begin
   if ({COMObjShellPropSheetExt.}DLLRefCount > 0) then begin
      Result := S_FALSE;
   end else begin
      Result := COMServ.DllCanUnloadNow;
   end; { else }
{$IFDEF Debug}
if Result <> S_FALSE then
Loggit('DllCanUnloadNow returns True')
else
Loggit('DllCanUnloadNow returns False');
{$ENDIF}
end; { DllCanUnloadNow }

exports
   DllGetClassObject resident,
   DllCanUnloadNow resident,
   DllRegisterServer resident,
   DllUnregisterServer resident;

begin
end. { library DUTDelShellExtensions }
