unit DUTShellPropertySheet;
{$DEFINE Debug}
(*
   Daniel U. Thibault
   <D.U.Thibault@Bigfoot.com>
   27 February 1999
    1999 Daniel U. Thibault.  All Rights Reserved.

   This is freeware.  No legally binding promises.  If you use the 
   component or any part of its code, you must include an 
   acknowledgement in the finished code or executable (in the About 
   box and/or the Help file).

   The shell PropertySheet extension.

   The .DEL file property sheet displays the "magic number" of
   each selected .DEL file and allows them to be zeroed.
*)
interface

uses
//   Classes,            { TStringList }
   Windows,
//   CommCtrl,           { TFNAddPropSheetPage, etc. }
//   ActiveX,            { IDataObject }
//   ShlObj,             { IShellPropSheetExt, etc. }
   COMObjShellPropSheetExt; { TCOMObjShellPropSheetExt }

const
   CLSID_DelPropSheet : TGUID = (
      D1:$6A5EF9E3; D2:$DFCE; D3:$11CF; D4:($9A, $34, $44, $45, $53, $54, $00, $00));

type
   TDUTShellPropertySheet = class(TCOMObjShellPropSheetExt)
   protected
      function DoAddPage(Page : TPropertySheetPage) : Boolean; override;
   end;

implementation

uses
{$IFDEF Debug}
DLLDebug, { Loggit }
SysUtils, { IntToStr }
{$ENDIF}
//   SysUtils, { StrDispose, Format, etc. }
   COMObj,   { TComObjectFactory, etc. }
   COMServ;  { COMServer }
//   DUTUtilsSys, { GetChildByID }
//   DUTDelShellUtils;

var
   DUTPropertyPage : TPropertySheetPage;
   PagesAdded      : Integer;

{ ########## TDUTShellPropertySheet ########## }

//These need to be customizable
{..$R DUTShellPropertySheet.RES}
{$I DUTShellPropertySheet.INC}
{
   psDialog    = 100;
   IDC_Static  = 101;
   IDC_ListBox = 102;
   IDC_Button  = 103;
}

function TDUTShellPropertySheet.DoAddPage(Page : TPropertySheetPage) : Boolean;
{
   TDUTShellPropertySheet will be invalid once DoAddPage returns False.
}
begin
{$IFDEF Debug}
Loggit('TDUTShellPropertySheet.DoAddPage');
{$ENDIF}
// Result := inherited DoAddPage(Page);
   //We wish to add just one page
   Result := (PagesAdded = 0);
   if not Result then Exit;
{$IFDEF Debug}
Loggit('TDUTShellPropertySheet.DoAddPage: Modifying the blank page');
{$ENDIF}
   Page.Title := 'Magic Number';
   if Page.Files.Count > 1 then Page.Title := Page.Title + 's';
   Page.Template.Height := 178;
   Page.Template.Width  := 194;
   Page.Template.Title  := 'Property Sheet Example';
   Page.Template.Font.Name := 'Arial';
   Page.Template.Font.Size := 9;
   Page.Template.AcceptDroppedFiles := True;
   Page.Template.HasHelp := True;
   Page.Template.HelpFile := 'D:\Borland\Delphi 3\Help\Additional Notes.hlp';
// Page.Template.HelpContext := 0;
   // LTEXT "", IDC_Static, 6, 6, 182, 8, SS_NOPREFIX
   Page.Template.AddItem(WS_CHILD or WS_VISIBLE or WS_GROUP or SS_NOPREFIX { $50020080 Style }, $00000000, 6, 6, 182, 8, IDC_STATIC {ID}, -1 {HelpContext}, $0082 { Static }, '' { ClassName }, '' { Title }, [$0000] { CreationData });
   // LTEXT "#\tName", -1, 6, 16, 182, 8, SS_NOPREFIX
   Page.Template.AddItem(WS_CHILD or WS_VISIBLE or WS_GROUP or SS_NOPREFIX { $50020080 Style }, $00000000, 6, 16, 182, 8, -1 {ID}, -1 {HelpContext}, $0082 { Static }, '' { ClassName }, '#'+#9+'Name' { Title }, [$0000] { CreationData });
   // LISTBOX IDC_ListBox, 6, 26, 182, 125, LBS_SORT | LBS_USETABSTOPS | WS_VSCROLL
   Page.Template.AddItem(WS_CHILD or WS_VISIBLE or WS_BORDER or WS_VSCROLL or LBS_USETABSTOPS or LBS_SORT or LBS_NOTIFY { $50A00083 Style }, $00000000, 6, 26, 182, 125, IDC_ListBox {ID}, 60 {HelpContext}, $0083 { List box }, '' { ClassName }, '' { Title }, [$0000] { CreationData });
   // PUSHBUTTON "&Zero Out", IDC_Button, 6, 152, 40, 15
   Page.Template.AddItem(WS_CHILD or WS_VISIBLE or WS_TABSTOP { $50010000 Style }, $00000000, 6, 152, 40, 15, IDC_BUTTON {ID}, 1000 {HelpContext}, $0080 { Button }, '' { ClassName }, '&Zero Out' { Title }, [$0000] { CreationData });
   DUTPropertyPage := Page;
   Inc(PagesAdded);
{$IFDEF Debug}
Loggit('TDUTShellPropertySheet.DoAddPage: Page modified');
{$ENDIF}
end; { TDUTShellPropertySheet.DoAddPage }

initialization
   TComObjectFactory.Create(COMServer, TDUTShellPropertySheet, CLSID_DelPropSheet, '', 'DUTShellPropertySheet', ciMultiInstance);
   PagesAdded := 0;

end. { unit DUTShellPropertySheet }
